****************************************************************************
* Project:	ultraDev
* Module:	UDTerminal
* Code:		ultra
* Created:	27.12.2019
* Notes:	can be used to create a terminal like screen area
*			which means you print text and at the end of the
*			screen the text scrolls up.
*			by setting the start line for example to 16 you
*			can have a scroll area at the bottom of the screen
*			upper area is not touched means you can show 
*			stuff here...
*			use UDTermPrint to print stuff into the terminal !
* Modified:
* Changes:
*
* (c) 2019 cream
****************************************************************************

****************************************************************************
UDTermInit:
;inits the terminal
;->d0 start line
	tst		d0
	bpl.s	.UDTermNo1
	moveq	#0,d0
.UDTermNo1:
	cmp		#UDScrCharsY-1,d0
	blt.s	.UDTermNo2
	moveq	#UDScrCharsY-2,d0
.UDTermNo2:
	move	d0,UDTermStart
	neg		d0
	add		#UDScrCharsY,d0
	move	d0,UDTermLines

	bsr		UDTermClear
	bsr		UDTermUpdate
	rts

****************************************************************************
UDTermClear:
	lea		UDTermScreen(pc),a0
	move	#(UDScrCharsX*(UDScrCharsY+1))-1,d0
.UDTermClearLoop:
	clr.w	(a0)+
;	move	#'a'-$20+$700,(a0)+
	dbf		d0,.UDTermClearLoop

	move	#0,UDTermCurLine
	rts

****************************************************************************
UDTermUpdate:
	move	#0,d0
	move	UDTermStart,d1
	bsr		UDDbgScrSetPosition

	move	UDTermLines,d3
	mulu	#UDScrCharsX,d3
	subq	#1,d3

	lea		UDTermScreen(pc),a0
	lea		$fb0000,a1
	move	UDRegWriteToScreen,d2
.UDTermUpdateLoop:
	move	(a0)+,d2
	add		d2,d2
	move	(a1,d2),d2		;write char
	dbf		d3,.UDTermUpdateLoop
	rts

****************************************************************************
UDTermPrint:
;prints a 0 terminated string in the given color.
;it can print hex values very like printf
;default color is white
;
;special chars:
;10 return
;01,<color> will set the color of the text
;
;printing hex values:
;the var args are pointers to the values to print
;"%b" will print a byte value in hex
;"%w" will print a word value in hex
;"%l" will print a long value in hex
;
; ->a0 text
; ->a1-a5 var args
	move	#$700,d2

	lea		UDTermScreen,a6
	move	UDTermCurLine,d1
	mulu	#UDScrCharsX*2,d1
	add		d1,a6
	moveq	#0,d0
.UDTermPrintLoop:
	move.b	(a0)+,d2
	beq		.UDTermPrintEnd

	cmp.b	#10,d2			; handle returns
	bne.s	.UDTermPrintNoReturn
.UDTermHandleReturn:
	moveq	#0,d0
	move	UDTermLines,d1
	cmp		UDTermCurLine,d1
	bne.s	.UDTermScrEnd11
	bsr		UDTerminScroll
	bra.s	.UDTermScrEnd22

.UDTermScrEnd11:
	add		#1,UDTermCurLine
.UDTermScrEnd22:


	move	UDTermCurLine,d7
	lea		UDTermScreen,a6
	move	d7,d1
	mulu	#UDScrCharsX*2,d1
	add		d1,a6
	bra.s	.UDTermPrintLoop

.UDTermPrintNoReturn:

	cmp.b	#1,d2			;handle colors
	bne.s	.UDTermNoCol
	moveq	#0,d2
	move.b	(a0)+,d2
	lsl		#8,d2
	bra.s	.UDTermPrintLoop

.UDTermNoCol:

	cmp.b	#'%',d2			;handle hex printing
	bne.s	.UDTermNoPrintHex
	move.b	(a0)+,d2

	cmp.b	#'b',d2
	bne.s	.UDTermNoPrintHexByte
	move.b	(a1),d7
	bsr		UDTermPrintByte

	bra.s	.UDTermScrollVarArgs
.UDTermNoPrintHexByte:

	cmp.b	#'w',d2
	bne.s	.UDTermNoPrintHexWord
	move.b	(a1)+,d7
	bsr		UDTermPrintByte
	move.b	(a1)+,d7
	bsr		UDTermPrintByte

	bra.s	.UDTermScrollVarArgs

.UDTermNoPrintHexWord:
	cmp.b	#'l',d2
	bne.s	.UDTermNoPrintHexLong
	move.b	(a1)+,d7
	bsr		UDTermPrintByte
	move.b	(a1)+,d7
	bsr		UDTermPrintByte
	move.b	(a1)+,d7
	bsr		UDTermPrintByte
	move.b	(a1)+,d7
	bsr		UDTermPrintByte
	bra.s	.UDTermScrollVarArgs

.UDTermNoPrintHexLong:
	bra.s	.UDTermNoPrintHex

.UDTermScrollVarArgs:
	move.l	a2,a1
	move.l	a3,a2
	move.l	a4,a3
	move.l	a5,a4
	bra		.UDTermPrintLoop
.UDTermNoPrintHex:
	sub.b	#$20,d2
	move	d2,(a6)+

	addq	#1,d0
	cmp		#UDScrCharsX,d0
	bne.s	.UDTermNoEOL
	moveq	#0,d0
	bra		.UDTermHandleReturn

.UDTermNoEOL:
	bra		.UDTermPrintLoop

.UDTermPrintEnd:
	move	UDTermLines,d1
	cmp		UDTermCurLine,d1
	bne.s	.UDTermScrEnd1
	bsr		UDTerminScroll
	bra.s	.UDTermScrEnd2

.UDTermScrEnd1:
	add		#1,UDTermCurLine
.UDTermScrEnd2:

	bsr		UDTermUpdate
	rts

UDTermPrintByte:
;intern use only !
	movem.l	a0/d2/d6/d7,-(a7)
	lea		UDTermHex,a0
	and		#$ff,d7

	move	d7,d6
	and		#$f0,d6
	lsr		#4,d6
	move.b	(a0,d6),d2
	sub.b	#$20,d2
	move.w	d2,(a6)+

	and		#$f,d7
	move.b	(a0,d7),d2
	sub.b	#$20,d2
	move.w	d2,(a6)+

	addq	#2,d0
	movem.l	(a7)+,a0/d2/d6/d7
	rts
****************************************************************************
UDTerminScroll:
	movem.l	d0/a0-a1,-(a7)	
	lea		UDTermScreen,a0
	lea		UDScrCharsX*2(a0),a1
	move	#(UDScrCharsX*(UDScrCharsY))-1,d0
.UDTerminScrollLoop:
	move	(a1)+,(a0)+
	dbf		d0,.UDTerminScrollLoop
	movem.l	(a7)+,d0/a0-a1
	rts

****************************************************************************
UDTermHex: dc.b "0123456789abcdef"

UDTermStart:	dc.w	0
UDTermLines:	dc.w	0
UDTermCurLine:	dc.w	0

UDTermScreen:	ds.w	UDScrCharsX*(UDScrCharsY+1)
